/***************************************************************************
****************************************************************************
**               Copyright (C) 2009 by Warzin ,  FYM Int.                 **
**                                                                        **
**                        warzin.warzin@gmail.com                         **
**                                                                        **
****************************************************************************
****************************************************************************
********                                                          **********
********              KDE Plasma applet  Mountoid                 **********
********                                                          **********
****************************************************************************
****************************************************************************
**                                                                        **
**   This program is free software; you can redistribute it and/or modify **
**   it under the terms of the GNU General Public License as published by **
**   the Free Software Foundation; either version 2 of the License, or    **
**   (at your option) any later version.                                  **
**                                                                        **
**   This program is distributed in the hope that it will be useful,      **
**   but WITHOUT ANY WARRANTY; without even the implied warranty of       **
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        **
**   GNU General Public License for more details.                         **
**                                                                        **
**   You should have received a copy of the GNU General Public License    **
**   along with this program; if not, write to the                        **
**   Free Software Foundation, Inc.,                                      **
**   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            **
**                                                                        **
****************************************************************************
****************************************************************************/
#include "dia_appearance.h"
//////////////////////////////


/////////////////////////////////////////////////////////////
/////         																					/////
/////     Class Dia_Appearance													/////
/////         																					/////
/////////////////////////////////////////////////////////////

//////////////////// Uncommented plain self-explanatory boring stuff

Dia_Appearance::Dia_Appearance 	(QWidget *par): QWidget(par)
{
		ui.setupUi(this);
		connect(ui.ls_colors,SIGNAL(currentRowChanged(int)),this,SLOT(sync_widgets()));
		connect(ui.cb_view,SIGNAL(currentIndexChanged(int)),this,SLOT(sync_widgets()));
				
		old_index=-1;
 		enable_widgets();
}

void	Dia_Appearance::set_value							(const AppearanceStructure &set)
{
	settings=set;
	fill_widgets();
}

AppearanceStructure	Dia_Appearance::get_value							()
{
	sync_values();
	return settings;
}
		
void	Dia_Appearance::fill_widgets					()
{
	int n=0;
	while (n<N_COLORS)
		ui.ls_colors->addItem(COLORS_NAME[COLOR_ORDER[n++]]);
	n=0;
	while (n<N_VIEW_MODE)
		ui.cb_view->addItem(VIEW_MODE_NAME[n++]);
	
	ui.chk_bkgrnd->setChecked(settings.show_background);
	ui.bt_font->setFont(settings.font);
	ui.bt_font_space->setFont(settings.font_space);
	ui.cb_view->setCurrentIndex((int)settings.view_mode);
	ui.sp_digits->setValue(settings.digits);
	ui.sp_OS_size->setValue(settings.OS_size);
	ui.sp_connect_size->setValue(settings.connect_size);
	ui.sp_mounting_size->setValue(settings.mounting_size);
	sync_widgets();
}

void	Dia_Appearance::sync_values						()
{
	settings.show_background=ui.chk_bkgrnd->isChecked();
	settings.font=ui.bt_font->font();
	settings.font_space=ui.bt_font_space->font();
	settings.digits=ui.sp_digits->value();
	settings.OS_size=ui.sp_OS_size->value();
	settings.connect_size=ui.sp_connect_size->value();
	settings.mounting_size=ui.sp_mounting_size->value();
	settings.view_mode=(ViewMode)ui.cb_view->currentIndex();
	
	if (ui.ls_display->currentRow()>=0)
		for (int m=0;m<N_DISPLAY_MODE;m++)
			if (DISPLAY_MODE_NAME[m]==ui.ls_display->currentItem()->text())
				settings.display_mode=(DisplayMode)m;
	
	int n=old_index;
	if ((n<0) || (n>=N_COLORS))
			return;
	
	settings.colors[COLOR_ORDER[n]]=ui.bt_colors->color();
}

void	Dia_Appearance::sync_widgets					()
{	
	
 	int n=ui.cb_view->currentIndex();
	if ((n>=0) && (n<N_VIEW_MODE))
	{
		ui.ls_display->clear();
		for (int m=0;m<N_DISPLAY_MODE;m++)
			if (DISPLAY_MODE_VIEW[m]==n)
			{
				ui.ls_display->addItem(DISPLAY_MODE_NAME[m]);
				if (settings.display_mode==m)
					ui.ls_display->setCurrentRow(ui.ls_display->count()-1);
			}		
	}
	enable_widgets();
	n=ui.ls_colors->currentRow();
 	if ((n<0) || (n>=N_COLORS))
 			return;
	sync_values();
	ui.bt_colors->setColor(settings.colors.at(COLOR_ORDER[n]));
	
	enable_widgets();
 	old_index=n;
}

void Dia_Appearance::enable_widgets()
{
	ui.bt_colors->setEnabled(ui.ls_colors->currentRow()>=0);
	ui.ls_display->setEnabled(ui.ls_display->count());
}
