/***************************************************************************
****************************************************************************
**               Copyright (C) 2009 by Warzin ,  FYM Int.                 **
**                                                                        **
**                        warzin.warzin@gmail.com                         **
**                                                                        **
****************************************************************************
****************************************************************************
********                                                          **********
********              KDE Plasma applet  Mountoid                 **********
********                                                          **********
****************************************************************************
****************************************************************************
**                                                                        **
**   This program is free software; you can redistribute it and/or modify **
**   it under the terms of the GNU General Public License as published by **
**   the Free Software Foundation; either version 2 of the License, or    **
**   (at your option) any later version.                                  **
**                                                                        **
**   This program is distributed in the hope that it will be useful,      **
**   but WITHOUT ANY WARRANTY; without even the implied warranty of       **
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        **
**   GNU General Public License for more details.                         **
**                                                                        **
**   You should have received a copy of the GNU General Public License    **
**   along with this program; if not, write to the                        **
**   Free Software Foundation, Inc.,                                      **
**   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            **
**                                                                        **
****************************************************************************
****************************************************************************/
#ifndef DIA_DEVICES_HEADER
#define DIA_DEVICES_HEADER
//////////////////
#include <QWidget>
///////////////////////
#include "ui_devices.h"
#include "device.h"

// This class provides a widget for filling the tab-page 'Devices' of the Plasmoid Settings dialog
class Dia_Devices : public QWidget
{
	Q_OBJECT
	public:
													Dia_Devices 	(QWidget *par);
							
		// Give to the dialog the current configuration					
		void									set_value							(const QList<Device*> &dev , const QList<int> &);
		// Get from the dialog the new configuration
		QList<DeviceInfo>			get_value							();
		QList<int>						get_order							();
    		
	protected slots:
		// Takes care of filling the widgets with appropriate informations
		void									fill_widgets					();
		// Keeps our configuration up-to-date by reading the widgets content
		// in particular when the user selects another device in the list
		void									sync_values						();
		// Keeps widgets content up-to-date according to some widgets state or behaviour
		// in particular when the user selects another device in the list
		void									sync_widgets					();
		// Some widgets need not be active according to some widgets state or behaviour
		void 									enable_widgets				();
		// Called when the user selects a device type
		// in order to sync the content of the corresponding icon button
		void 									type_changed					();
		// Called when the user selects an OS type
		// in order to sync the content of the corresponding icon button
		void 									OS_changed						();
		// Called when the user changes the order of devices
		void									bt_clicked						();
		// Initialize the content of the devices list
		void									fill_devices					();
		
 	protected:
		// The Designer object
 		Ui_devices					 	ui;
		// Current configuration
		QList<DeviceInfo>			list;
		// Needed for sync_values() : remembers the previous device
		int										old_index;
		// Keeps track of the devices order
		QList<int>						order;
};


#endif