/***************************************************************************
****************************************************************************
**               Copyright (C) 2009 by Warzin ,  FYM Int.                 **
**                                                                        **
**                        warzin.warzin@gmail.com                         **
**                                                                        **
****************************************************************************
****************************************************************************
********                                                          **********
********              KDE Plasma applet  Mountoid                 **********
********                                                          **********
****************************************************************************
****************************************************************************
**                                                                        **
**   This program is free software; you can redistribute it and/or modify **
**   it under the terms of the GNU General Public License as published by **
**   the Free Software Foundation; either version 2 of the License, or    **
**   (at your option) any later version.                                  **
**                                                                        **
**   This program is distributed in the hope that it will be useful,      **
**   but WITHOUT ANY WARRANTY; without even the implied warranty of       **
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        **
**   GNU General Public License for more details.                         **
**                                                                        **
**   You should have received a copy of the GNU General Public License    **
**   along with this program; if not, write to the                        **
**   Free Software Foundation, Inc.,                                      **
**   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            **
**                                                                        **
****************************************************************************
****************************************************************************/
#include "dia_preferences.h"
//////////////////////////////


/////////////////////////////////////////////////////////////
/////         																					/////
/////     Class Dia_Preferences													/////
/////         																					/////
/////////////////////////////////////////////////////////////

//////////////////// Uncommented plain self-explanatory boring stuff

Dia_Preferences::Dia_Preferences 	(QWidget *par): QWidget(par)
{
		ui.setupUi(this);
		connect(ui.rd_unit,SIGNAL(toggled(bool)),this,SLOT(enable_widgets()));
		enable_widgets();
}

void	Dia_Preferences::set_value							(const PreferenceStructure &set)
{
	settings=set;
	fill_widgets();
}

PreferenceStructure	Dia_Preferences::get_value							()
{
	sync_values();
	return settings;
}
		
void	Dia_Preferences::fill_widgets					()
{
	int n=0;
	while (n<N_UNITS)
		ui.cb_unit->addItem(UNIT_NAME[n++]);
	
	ui.sp_refresh->setValue(settings.refresh_rate);
	ui.sp_timeout->setValue(settings.mount_timeout);
	ui.sp_ping->setValue(settings.ping_timeout);
	ui.rd_best->setChecked(settings.use_best_unit);
	ui.rd_unit->setChecked(!settings.use_best_unit);
	ui.cb_unit->setCurrentIndex((int)settings.size_unit);
	ui.chk_free->setChecked(settings.is_free_space);
	ui.chk_used->setChecked(settings.is_used_space);
	ui.chk_max->setChecked(settings.is_max_space);
	sync_widgets();
}

void	Dia_Preferences::sync_values						()
{
	settings.refresh_rate=ui.sp_refresh->value();
	settings.mount_timeout=ui.sp_timeout->value();
	settings.ping_timeout=ui.sp_ping->value();
	settings.use_best_unit=ui.rd_best->isChecked();
	settings.size_unit=(Unit)ui.cb_unit->currentIndex();
	settings.is_free_space=ui.chk_free->isChecked();
	settings.is_used_space=ui.chk_used->isChecked();
	settings.is_max_space=ui.chk_max->isChecked();
}

void	Dia_Preferences::sync_widgets					()
{	
	enable_widgets();
}

void Dia_Preferences::enable_widgets()
{
	ui.cb_unit->setEnabled(ui.rd_unit->isChecked());
}
