/***************************************************************************
****************************************************************************
**               Copyright (C) 2009 by Warzin ,  FYM Int.                 **
**                                                                        **
**                        warzin.warzin@gmail.com                         **
**                                                                        **
****************************************************************************
****************************************************************************
********                                                          **********
********              KDE Plasma applet  Mountoid                 **********
********                                                          **********
****************************************************************************
****************************************************************************
**                                                                        **
**   This program is free software; you can redistribute it and/or modify **
**   it under the terms of the GNU General Public License as published by **
**   the Free Software Foundation; either version 2 of the License, or    **
**   (at your option) any later version.                                  **
**                                                                        **
**   This program is distributed in the hope that it will be useful,      **
**   but WITHOUT ANY WARRANTY; without even the implied warranty of       **
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        **
**   GNU General Public License for more details.                         **
**                                                                        **
**   You should have received a copy of the GNU General Public License    **
**   along with this program; if not, write to the                        **
**   Free Software Foundation, Inc.,                                      **
**   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            **
**                                                                        **
****************************************************************************
****************************************************************************/
#ifndef DIA_PREFERENCES_HEADER
#define DIA_PREFERENCES_HEADER
/////////////////////
#include <QWidget>
///////////////////////////
#include "ui_preferences.h"
#include "settings.h"
//////////////////////////

// This class provides a widget for filling the tab-page 'Preferences' of the Plasmoid Settings dialog
class Dia_Preferences : public QWidget
{
	Q_OBJECT
	public:
													Dia_Preferences 			(QWidget *par);
							
		// Give to the dialog the current configuration
		void									set_value							(const PreferenceStructure &set);		
		// Get from the dialog the new configuration
		PreferenceStructure		get_value							();
    		
	protected slots:
		// Takes care of filling the widgets with appropriate informations
		void									fill_widgets					();
		// Keeps our configuration up-to-date by reading the widgets content
		void									sync_values						();
		// Keeps widgets content up-to-date according to some widgets state or behaviour
		void									sync_widgets					();
		// Some widgets need not be active according to some widgets state or behaviour
		void 									enable_widgets				();
		
 	protected:
		// The Designer object
 		Ui_preferences				ui;
		// Current configuration
		PreferenceStructure		settings;
};


#endif