/***************************************************************************
****************************************************************************
**               Copyright (C) 2009 by Warzin ,  FYM Int.                 **
**                                                                        **
**                        warzin.warzin@gmail.com                         **
**                                                                        **
****************************************************************************
****************************************************************************
********                                                          **********
********              KDE Plasma applet  Mountoid                 **********
********                                                          **********
****************************************************************************
****************************************************************************
**                                                                        **
**   This program is free software; you can redistribute it and/or modify **
**   it under the terms of the GNU General Public License as published by **
**   the Free Software Foundation; either version 2 of the License, or    **
**   (at your option) any later version.                                  **
**                                                                        **
**   This program is distributed in the hope that it will be useful,      **
**   but WITHOUT ANY WARRANTY; without even the implied warranty of       **
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        **
**   GNU General Public License for more details.                         **
**                                                                        **
**   You should have received a copy of the GNU General Public License    **
**   along with this program; if not, write to the                        **
**   Free Software Foundation, Inc.,                                      **
**   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            **
**                                                                        **
****************************************************************************
****************************************************************************/
#ifndef ICON_VIEW_WIDGET_HEADER
#define ICON_VIEW_WIDGET_HEADER
/////////////////////////////
#include <QGraphicsWidget>
/////////////////////////////
#include "mountoid_view.h"
////////////////////////////

class TextWidget;
class IconWidget;

//////////////////////////////////////////////////////////////////
// this class implements the icon view mode


class IconViewWidget : public MountoidView
{
	Q_OBJECT
	public:
													IconViewWidget								(QGraphicsWidget *par, 
																												 QList<Device*> *list , 
																												 SettingsStructure *set);
		// postions the devices according ot their display rank
		virtual		void 				apply_new_size								(QSizeF &);
		// sync devices list and associated icons/texts
		// called to populate the icon view
		virtual		void				load_devices									();
		// change between horizontal and vertical stacking
		virtual 	void				set_display_mode							(const DisplayMode &);
		// something changed, keep track of it
		virtual	 	void				some_data_changed							(const int &);
		// minimum size of the view
		virtual QSizeF				get_minimum_size							();
		// used when dragging an icon to change its position
		bool									is_moving;
		// called by the moving icon to find its new display rank according to its scene position
		void									icon_moving										(IconWidget*);
		
	protected:
		// the icon- and text-widgets of the devices
		QList<IconWidget*>		icons;
		QList<TextWidget*>		texts;
		
	private slots:
		// to update the load indicator icon
		void					 				load_state_changed						(Device*);
		// slot receiving animation calls
		void									animation_next_step						();
};


#endif