/***************************************************************************
****************************************************************************
**               Copyright (C) 2009 by Warzin ,  FYM Int.                 **
**                                                                        **
**                        warzin.warzin@gmail.com                         **
**                                                                        **
****************************************************************************
****************************************************************************
********                                                          **********
********              KDE Plasma applet  Mountoid                 **********
********                                                          **********
****************************************************************************
****************************************************************************
**                                                                        **
**   This program is free software; you can redistribute it and/or modify **
**   it under the terms of the GNU General Public License as published by **
**   the Free Software Foundation; either version 2 of the License, or    **
**   (at your option) any later version.                                  **
**                                                                        **
**   This program is distributed in the hope that it will be useful,      **
**   but WITHOUT ANY WARRANTY; without even the implied warranty of       **
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        **
**   GNU General Public License for more details.                         **
**                                                                        **
**   You should have received a copy of the GNU General Public License    **
**   along with this program; if not, write to the                        **
**   Free Software Foundation, Inc.,                                      **
**   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            **
**                                                                        **
****************************************************************************
****************************************************************************/
#ifndef LIST_VIEW_WIDGET_HEADER
#define LIST_VIEW_WIDGET_HEADER
/////////////////////////////
#include <QItemDelegate>
/////////////////////////////
#include "mountoid_view.h"
////////////////////////////
class KListWidget;
class QListWidgetItem;

//////////////////////////////////////////////////////////////////
// this class implements the list view mode

class ListViewWidget : public MountoidView
{
	Q_OBJECT
	public:
													ListViewWidget								(QGraphicsWidget *par, 
																												 QList<Device*> *list , 
																												 SettingsStructure *set);
		// inserts the devices as items in the list according ot their display rank
		virtual		void 				apply_new_size								(QSizeF &);
		// sync devices list and associated icons
		// called to populate the listview
		virtual		void				load_devices									();
		// something change, keep track of it
		virtual	 	void				some_data_changed							(const int &);
		// not used, only one display mode here
		virtual 	void				set_display_mode							(const DisplayMode &);
		// minimum size of the view
		virtual QSizeF				get_minimum_size							();
		
	protected:
		// the actual listwidget
		KListWidget						*list;
		// used by ItemDelegate to obtain the item's text of the given row
		// crappy but I didn't want to subclass the whole ListWidgetItem
		QString								get_item_text									(const int &);
		
	protected slots:
		// needed to find which device is below the mouse when requesting the contextual menu
		void									context_menu									(const QPoint&);
		// which device has been clicked? calls MountoidView icon_clicked() with the found device
		void									clicked												(QListWidgetItem*);
		// slot receiving animation calls
		void									animation_next_step						();
		
};

//////////////////////////////////////////////////////////
// this class allows a customized display of list items

class ItemDelegate : public QItemDelegate
{
  Q_OBJECT 
  public:
													ItemDelegate									(ListViewWidget *parent);

		// do the actual drawing
		void 									paint													(QPainter *painter, 
																												 const QStyleOptionViewItem &option,
																												 const QModelIndex &index) const;
		// get the size of the row
    QSize 								sizeHint											(const QStyleOptionViewItem &option,
																												 const QModelIndex &index) const;
																												 
	protected:
		// the parent, in order to have content information
		// crappy but I didn't want to subclass the whole ListWidgetItem
		ListViewWidget				*listview;
};


#endif