/***************************************************************************
****************************************************************************
**               Copyright (C) 2009 by Warzin ,  FYM Int.                 **
**                                                                        **
**                        warzin.warzin@gmail.com                         **
**                                                                        **
****************************************************************************
****************************************************************************
********                                                          **********
********              KDE Plasma applet  Mountoid                 **********
********                                                          **********
****************************************************************************
****************************************************************************
**                                                                        **
**   This program is free software; you can redistribute it and/or modify **
**   it under the terms of the GNU General Public License as published by **
**   the Free Software Foundation; either version 2 of the License, or    **
**   (at your option) any later version.                                  **
**                                                                        **
**   This program is distributed in the hope that it will be useful,      **
**   but WITHOUT ANY WARRANTY; without even the implied warranty of       **
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        **
**   GNU General Public License for more details.                         **
**                                                                        **
**   You should have received a copy of the GNU General Public License    **
**   along with this program; if not, write to the                        **
**   Free Software Foundation, Inc.,                                      **
**   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.            **
**                                                                        **
****************************************************************************
****************************************************************************/
#ifndef TEXT_WIDGET_HEADER
#define TEXT_WIDGET_HEADER
///////////////////////////
#include <QGraphicsItem>
///////////////////////////
class Device;
class IconViewWidget;
//////////////////////////////
//////////////////////////////

// This class provides the GraphicsItem to display the device text nickname and device free space

class TextWidget : public QGraphicsItem
{
	public:
										TextWidget						(Device* par , 
																					 IconViewWidget *vpar);
		// paints the widget
		void 						paint									(QPainter *painter,
																					const QStyleOptionGraphicsItem *option,
																					QWidget *par);
		// sets the width, and compute automatically the font size to fit the text in
		void						set_width							(const float &);
		// returns the total displayed height
		float						get_height						() const;
		// returns the height of the nickname text
		float						get_nick_name_height	() const;
		// sync the font with the applet settings
		void						refresh_font					();
		// return the rect containing the text
		virtual QRectF	boundingRect					() const;
		// sync data from the device when something changes
		void						data_changed					();
		
	protected:
		// creates and positions the different rects containing the different texts
		void						manage_rects					();
		// returns the width of the widest displayed text block amongst nickname, free,used and max space
		float						get_space_width				() const;
				
	private:
		// the parent device
		Device					*par_dev;		
		// the icon view
		IconViewWidget	*view;		
		// the display fonts
		QFont						font;
		QFont						font_space;
		// the display rects of the different texts
		QRectF					rect_nick_name;
		QRectF					rect_free_space;
		QRectF					rect_used_space;
		QRectF					rect_max_space;
		// this is actually the width of the device icon
		float						allocated_width;
		
};

#endif